## Java code of the examples of Lecture 3

In this directory you can find different folders corresponding to the different examples we discuss in the Lecture and how to execute them (tested in a Linux machine).

### ex1

It contains two files:

* Counter.java - The counter example with the data race occurring when updating the variable `counter`.

* CounterS.java - The solution to the data race in the counter example using semaphores.

To run the examples you only need to compile the corresponding file

`javac Counter.java`

and executing the class with the main method

`java Counter`

### ex1b

It contains three files:

* Counter2.java - A different instantiation of the counter example where we create 20 threads that will update `counter`. In this case we want the queue of the semaphore to always be empty. However, the solution in this file does not enforce this property because it uses availablePermits() and afterwards acquires the semaphore. DO NOT USE availablePermits() in the lab.

* Counter3.java - This file contains the solution to the previous problem, we use tryAcquire() instead of availablePermits() which makes atomic checking and acquiring the semaphore.

* run.sh - A small shell script to run the program 10 times.

You can compile the files as defined above. For running it you can use the `./run.sh` (make sure that the right main class is called) or the `java` commandas described above.

### ex2

It contains 2 files:

* BoundedBuffer.java - A solution using monitors (Reentrantlock) to the Producer-Consumer problem (aka Bounded Buffer problem) with a buffer of size 5.

* Main.java - A main class that creates 10 producer threads and 10 consumer consumer threads that work on the previous bounded buffer. 

In this example you need to compile all java files

`javac *.java`

and run the main one

`java Main`

### bonus-ex3

* NetworkService.java - A program showing how to create and use a pool of a fixed number of threads by using the ExecutorService library from Java. A new task is submitted to the pool every time that request is sent to a socket in which the program is listenning.

* Main.java - It checks that the the parameters are correct and initiates the network service.

* socket-client - It sends 10000 messages to a socket in port 8.

As before, we compile all the java files

`javac *.java`

run the main program with 2 parameters, port and size of the pool of threads

`sudo java Main 8 5` -- Starts the service in port 8 and a pool with 5 threads

execute the shell script to send messages

`./socket-client`
