import java.net.*;
import java.io.*;
import java.util.*;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

class NetworkService extends Thread {
    private final ServerSocket serverSocket;
    private final ExecutorService pool;

    public NetworkService(int port, int poolsize) throws IOException {
	serverSocket = new ServerSocket(port);
	pool = Executors.newFixedThreadPool(poolsize);
    }

    public void run() {
	try {
	    while(true) {
		pool.submit(new Handler(serverSocket.accept()));
		// Thread t = new Thread(new Handler(serverSocket.accept()));
		// t.start();
	    }
	} catch (IOException e) {
	    pool.shutdown();
	}
    }

    class Handler implements Runnable {
	private final Socket socket;

	public Handler(Socket socket) {
	    this.socket = socket;	    
	}

	public void run() {
	    try {
		BufferedReader in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
		String inputLine;
		while((inputLine = in.readLine()) != null ) {
		    System.out.println("Message receive: " + inputLine);
		    //Do some computation that takes 1s
		    sleep(1000);
		}
	    } catch (IOException e) {
		System.out.println(e);
	    } catch (InterruptedException e) {
		System.out.println(e);
	    }
	}
    }
}
